mod backend;
mod gui;
pub mod protocol;
use std::{cell::RefCell, rc::Rc, thread};

use gtk4::{glib, prelude::ApplicationExtManual as _};

fn main() -> glib::ExitCode {
    env_logger::init();
    gtk4::init().expect("Failed to initialize GTK");
    let (to_frontent_tx, from_backend_rx) = tokio::sync::mpsc::channel(5);
    let _handle = thread::spawn(move || {
        tokio::runtime::Builder::new_current_thread()
            .enable_io()
            .enable_time()
            .build()
            .unwrap()
            .block_on(backend::run::run(to_frontent_tx))
            .expect("Failed to run or interrupted");
    });

    let app = gui::main_window::get_app(Rc::new(RefCell::new(Some(from_backend_rx))));

    app.run()
}
