use nom::{
    bytes::complete::is_not,
    bytes::complete::tag,
    character::complete::{multispace0, multispace1},
    sequence::{delimited, preceded, separated_pair},
    IResult,
};

pub(crate) fn quoted(input: &str) -> IResult<&str, &str> {
    preceded(multispace0, delimited(tag("\""), is_not("\n\""), tag("\"")))(input)
}

pub(crate) fn key_value(input: &str) -> IResult<&str, (&str, &str)> {
    //  note that this is really creating a function, the parser for abc
    //  vvvvv
    //         which is then called here, returning an IResult<&str, &str>
    //         vvvvv
    preceded(multispace0, separated_pair(quoted, multispace1, quoted))(input)
}
